(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
/*
 * JavaScript implementation of brUncompress.
 */

const fromBits = require("math-float32-from-bits")

const ST_UNDEF = 0
const ST_BL = 1
const ST_U4 = 2
const ST_I4 = 3
const ST_U8 = 4
const ST_I8 = 5
const ST_U16 = 6
const ST_I16 = 7
const ST_U24 = 8
const ST_I24 = 9
const ST_U32 = 10
const ST_I32 = 11
const ST_FL = 12

const BR_HUFF_MAX_INDEX_TABLE = 14
const NB_HUFF_ELEMENT = 16
const NUMBER_OF_SERIES = 16

const huff = [
  [
    { sz: 2, lbl: 0x000 },
    { sz: 2, lbl: 0x001 },
    { sz: 2, lbl: 0x003 },
    { sz: 3, lbl: 0x005 },
    { sz: 4, lbl: 0x009 },
    { sz: 5, lbl: 0x011 },
    { sz: 6, lbl: 0x021 },
    { sz: 7, lbl: 0x041 },
    { sz: 8, lbl: 0x081 },
    { sz: 10, lbl: 0x200 },
    { sz: 11, lbl: 0x402 },
    { sz: 11, lbl: 0x403 },
    { sz: 11, lbl: 0x404 },
    { sz: 11, lbl: 0x405 },
    { sz: 11, lbl: 0x406 },
    { sz: 11, lbl: 0x407 }
  ],
  [
    { sz: 7, lbl: 0x06f },
    { sz: 5, lbl: 0x01a },
    { sz: 4, lbl: 0x00c },
    { sz: 3, lbl: 0x003 },
    { sz: 3, lbl: 0x007 },
    { sz: 2, lbl: 0x002 },
    { sz: 2, lbl: 0x000 },
    { sz: 3, lbl: 0x002 },
    { sz: 6, lbl: 0x036 },
    { sz: 9, lbl: 0x1bb },
    { sz: 9, lbl: 0x1b9 },
    { sz: 10, lbl: 0x375 },
    { sz: 10, lbl: 0x374 },
    { sz: 10, lbl: 0x370 },
    { sz: 11, lbl: 0x6e3 },
    { sz: 11, lbl: 0x6e2 }
  ],
  [
    { sz: 4, lbl: 0x009 },
    { sz: 3, lbl: 0x005 },
    { sz: 2, lbl: 0x000 },
    { sz: 2, lbl: 0x001 },
    { sz: 2, lbl: 0x003 },
    { sz: 5, lbl: 0x011 },
    { sz: 6, lbl: 0x021 },
    { sz: 7, lbl: 0x041 },
    { sz: 8, lbl: 0x081 },
    { sz: 10, lbl: 0x200 },
    { sz: 11, lbl: 0x402 },
    { sz: 11, lbl: 0x403 },
    { sz: 11, lbl: 0x404 },
    { sz: 11, lbl: 0x405 },
    { sz: 11, lbl: 0x406 },
    { sz: 11, lbl: 0x407 }
  ]
]

/**
 * Convert the hex string given as parameter to a ByteArray
 */
function parseHexString(str) {
  str = str
    .split("")
    .filter(x => !isNaN(parseInt(x, 16)))
    .join("")
  console.log(str)
  const result = []
  while (str.length >= 2) {
    result.push(parseInt(str.substring(0, 2), 16))
    str = str.substring(2, str.length)
  }
  return result
}

/*
 * Function to create a buffer from a byteArray. Allow to read sample from the
 * byteArray to extract data.
 */
function createBuffer(byteArray) {
  return {
    index: 0,
    byteArray: byteArray,
    getNextSample: function(sampleType, nbBits) {
      let src_bit_start = this.index
      this.index += nbBits

      if (sampleType === ST_FL && nbBits !== 32) {
        throw "Mauvais sampletype"
      }

      let u32 = 0
      let nbytes = Math.trunc((nbBits - 1) / 8) + 1
      let nbitsfrombyte = nbBits % 8
      if (sampleType === ST_FL) {
      }
      if (nbitsfrombyte === 0 && nbytes > 0) {
        nbitsfrombyte = 8
      }

      while (nbytes > 0) {
        bittoread = 0
        while (nbitsfrombyte > 0) {
          let idx = src_bit_start >> 3
          if (this.byteArray[idx] & (1 << (src_bit_start & 0x07))) {
            u32 |= 1 << ((nbytes - 1) * 8 + bittoread)
          }
          nbitsfrombyte--
          bittoread++
          src_bit_start += 1
        }
        nbytes--
        nbitsfrombyte = 8
      }
      // Propagate the sign bit if 1
      if (
        (sampleType == ST_I4 || sampleType == ST_I24) &&
        u32 & (1 << (nbBits - 1))
      ) {
        for (let i = nbBits; i < 32; i++) {
          u32 |= 1 << i
          nbBits++
        }
      }

      return u32
    },

    /**
     * Extract sz and bi from Huff table
     */
    getNextBifromHi: function(huff_coding) {
      for (let i = 2; i < 12; i++) {
        const lhuff = bits_buf2HuffPattern(this.byteArray, this.index, i)
        // console.log(`lhuff ${lhuff}`)

        for (let j = 0; j < NB_HUFF_ELEMENT; j++) {
          if (
            huff[huff_coding][j].sz == i &&
            lhuff == huff[huff_coding][j].lbl
          ) {
            this.index += i
            return {
              sz: i,
              bi: j
            }
          }
        }
      }
      this.index += 0
      return { sz: 0, bi: null }
    }
  }
}

/**
 * Generate a flag object from an integer value.
 */
function generateFlag(flagAsInt) {
  let binbase = flagAsInt.toString(2)
  // leftpad
  while (binbase.length < 8) {
    binbase = "0" + binbase
  }

  return {
    cts: parseInt(binbase[binbase.length - 2], 2),
    no_sample: parseInt(binbase[binbase.length - 3], 2),
    batch_req: parseInt(binbase[binbase.length - 4], 2),
    nb_of_type_measure: parseInt(binbase.substring(0, 4), 2)
  }
}

function BM_ST_SZ(st) {
  return st > ST_I24
    ? 32
    : st > ST_I16
      ? 24
      : st > ST_I8
        ? 16
        : st > ST_I4
          ? 8
          : st > ST_BL
            ? 4
            : st > ST_UNDEF
              ? 1
              : 0
}

/**
 * Retrieve the pattern for huff table lookup
 */
function bits_buf2HuffPattern(byteArray, index, nb_bits) {
  let src_bit_start = index
  let sz = nb_bits - 1
  if (byteArray.length * 8 < src_bit_start + nb_bits) {
    throw "Verify that dest buf is large enough"
  }
  let bittoread = 0
  let pattern = 0
  while (nb_bits > 0) {
    if (byteArray[src_bit_start >> 3] & (1 << (src_bit_start & 0x07))) {
      pattern |= 1 << (sz - bittoread)
    }
    nb_bits--
    bittoread++
    src_bit_start++
  }
  return pattern
}

/**
 * brUncompress function
 */
function brUncompress(tagsz, argList, hexString, batch_absolute_timestamp) {
  const out = {
    batch_counter: 0,
    batch_relative_timestamp: 0,
    series: []
  }

  const bufferedLogger = {
    _buffer: "",
    append: function(str) {
      this._buffer += str
      return this
    },
    print: function() {
      if (this._buffer.trim() !== "") {
        console.log(this._buffer)
        this._buffer = ""
      }
      return this
    }
  }

  for (let i = 0; i < NUMBER_OF_SERIES; i++) {
    out.series.push({
      codingType: 0,
      codingTable: 0,
      compressSampleNb: 0,
      resolution: null,
      uncompressSamples: []
    })
  }

  const byteArray = new Uint8Array(parseHexString(hexString))
  const buffer = createBuffer(byteArray)
  const flag = generateFlag(buffer.getNextSample(ST_U8, 8))

  console.log(`nb_of_type_measure: ${flag.nb_of_type_measure}`)
  console.log(`batch requested: ${flag.batch_req}`)
  console.log(`no sample: ${flag.no_sample}`)
  console.log(`cts: ${flag.cts}`)

  const counter = buffer.getNextSample(ST_U8, 3)
  console.log(`cnt: ${counter}`)
  out.batch_counter = counter
  const ltemp2 = buffer.getNextSample(ST_U8, 1)

  let abs_timestamp = 0
  let last_timestamp = 0

  let tag = {}

  let index_of_the_first_sample = 0
  for (let i = 0; i < flag.nb_of_type_measure; i++) {
    tag = {
      size: tagsz,
      lbl: buffer.getNextSample(ST_U8, tagsz)
    }

    console.log(`tag lbl: ${tag.lbl}`)

    const ii = argList.findIndex(
      item => item.taglbl === tag.lbl && tagsz === tag.size
    )
    if (ii < 0) {
      throw "Cannot find index in argList"
    }
    bufferedLogger.append(` tag: ${tag.lbl} index ${ii}`)
    if (i == 0) {
      index_of_the_first_sample = ii
      const timestamp = buffer.getNextSample(ST_U8, BM_ST_SZ(ST_U32))
      abs_timestamp = timestamp
      out.series[ii].uncompressSamples.push({
        data_relative_timestamp: timestamp,
        data: {}
      })
      bufferedLogger.append(`  timestamp ${timestamp}`)
    } else {
      const { sz, bi } = buffer.getNextBifromHi(1)
      bufferedLogger.append(` bi ${bi}, sz ${sz}`)
      if (!sz) {
        throw "Wrong sz from szbi"
      }
      let t = 0
      if (bi <= BR_HUFF_MAX_INDEX_TABLE) {
        if (bi > 0) {
          //console.log(`Index before raw ${buffer.index}`)
          t = buffer.getNextSample(ST_U32, bi)
          //console.log(`abs_timestamp ${abs_timestamp}`)
          bufferedLogger.append(` raw: ${t}`)
          t += abs_timestamp + Math.pow(2, bi) - 1
        } else {
          t = abs_timestamp
        }
      } else {
        t = buffer.getNextSample(ST_U32, BM_ST_SZ(ST_U32))
      }
      out.series[ii].uncompressSamples.push({
        data_relative_timestamp: t,
        data: {}
      })
      abs_timestamp = t
      bufferedLogger.append(`  timestamp: ${abs_timestamp}`)
    }
    last_timestamp = abs_timestamp

    // Measure
    const v = buffer.getNextSample(
      argList[ii].sampletype,
      BM_ST_SZ(argList[ii].sampletype)
    )

    // console.log(`Type = ${argList[ii].sampletype}`)
    if (argList[ii].sampletype === ST_FL) {
      out.series[ii].uncompressSamples[0].data.value = fromBits(
        "0" + v.toString(2)
      )
    } else {
      out.series[ii].uncompressSamples[0].data.value = v
    }
    out.series[ii].uncompressSamples[0].data.label = tag.lbl
    bufferedLogger.append(
      ` Measure ${out.series[ii].uncompressSamples[0].data.value}`
    )

    if (!flag.no_sample) {
      out.series[ii].codingType = buffer.getNextSample(ST_U8, 2)
      out.series[ii].codingTable = buffer.getNextSample(ST_U8, 2)
      bufferedLogger
        .append(
          ` Coding type ${out.series[ii].codingType}, Coding table ${
            out.series[ii].codingTable
          }`
        )
        .print()
    }
  }
  if (!flag.no_sample) {
    if (flag.cts) {
      console.log("common time stamp")
      //number of sample
      const nb_sample_to_parse = buffer.getNextSample(ST_U8, 8)
      console.log(` number of sample: ${nb_sample_to_parse}`)

      //TimeStamp Coding
      const ltimestamp_coding = buffer.getNextSample(ST_U8, 2)
      console.log(` TimeStamp Coding(0-A/1-B/2-C): ${ltimestamp_coding}`)
      const timestampCommon = []
      for (let i = 0; i < nb_sample_to_parse; i++) {
        //delta timestamp
        let o = buffer.getNextBifromHi(ltimestamp_coding)
        sz = o.sz
        bi = o.bi
        if (!sz) {
          throw "sz"
        }
        bufferedLogger.print()
        bufferedLogger.append(`bi: ${bi} sz: ${sz}`)
        if (bi <= BR_HUFF_MAX_INDEX_TABLE) {
          if (i == 0) {
            timestampCommon.push(
              out.series[index_of_the_first_sample].uncompressSamples[0]
                .data_relative_timestamp
            )
          } else {
            if (bi > 0) {
              const raw = buffer.getNextSample(ST_U32, bi)
              bufferedLogger.append(` raw: ${raw}`)
              timestampCommon.push(
                raw + timestampCommon[i - 1] + Math.pow(2, bi) - 1
              )
            } else {
              timestampCommon.push(timestampCommon[i - 1])
            }
          }
        } else {
          timestampCommon.push(buffer.getNextSample(ST_U32, BM_ST_SZ(ST_U32)))
        }
        last_timestamp = timestampCommon[i]
        bufferedLogger.append(` timestamp: ${last_timestamp}`)
      }

      for (let j = 0; j < flag.nb_of_type_measure; j++) {
        let first_null_delta_value = 1
        tag.lbl = buffer.getNextSample(ST_U8, tagsz)
        bufferedLogger.print()
        bufferedLogger.append(` tag: ${tag.lbl}`)
        const ii = argList.findIndex(item => item.taglbl == tag.lbl)
        bufferedLogger.append(` index: ${ii}`)
        for (let i = 0; i < nb_sample_to_parse; i++) {
          //Available bit
          const available = buffer.getNextSample(ST_U8, 1)
          bufferedLogger.print().append(`${i}. available ${available} `)
          if (available) {
            bufferedLogger.append(`coding table: ${out.series[ii].codingTable}`)
            //Delta value
            const o = buffer.getNextBifromHi(out.series[ii].codingTable)
            bi = o.bi
            sz = o.sz
            if (!sz) {
              return 0
            }
            bufferedLogger.append(` bi: ${bi} sz: ${sz}`)
            const currentMeasure = {
              data_relative_timestamp: 0,
              data: {}
            }
            if (bi <= BR_HUFF_MAX_INDEX_TABLE) {
              if (bi > 0) {
                currentMeasure.data.value = buffer.getNextSample(ST_U16, bi)
                bufferedLogger.append(` RawValue: ${currentMeasure.data.value}`)
                if (out.series[ii].codingType === 0) {
                  // ADLC
                  if (currentMeasure.data.value >= Math.pow(2, bi - 1)) {
                    currentMeasure.data.value *= argList[ii].resol
                    currentMeasure.data.value +=
                      out.series[ii].uncompressSamples[
                        out.series[ii].uncompressSamples.length - 1
                      ].data.value
                  } else {
                    currentMeasure.data.value += 1 - Math.pow(2, bi)
                    currentMeasure.data.value *= argList[ii].resol
                    currentMeasure.data.value +=
                      out.series[ii].uncompressSamples[
                        out.series[ii].uncompressSamples.length - 1
                      ].data.value
                  }
                } else if (out.series[ii].codingType === 1) {
                  // Positive

                  currentMeasure.data.value += Math.pow(2, bi) - 1
                  currentMeasure.data.value *= argList[ii].resol
                  currentMeasure.data.value +=
                    out.series[ii].uncompressSamples[
                      out.series[ii].uncompressSamples.length - 1
                    ].data.value
                } else {
                  // Negative
                  currentMeasure.data.value += Math.pow(2, bi) - 1
                  currentMeasure.data.value *= argList[ii].resol
                  currentMeasure.data.value =
                    out.series[ii].uncompressSamples[
                      out.series[ii].uncompressSamples.length - 1
                    ].data.value - currentMeasure.data.value
                }
                bufferedLogger.append(`  Value: ${currentMeasure.data.value}`)
              } else {
                // (bi <= 0)
                if (first_null_delta_value) {
                  // First value is yet recorded starting from the header
                  first_null_delta_value = 0
                  continue
                } else {
                  currentMeasure.data.value =
                    out.series[ii].uncompressSamples[
                      out.series[ii].uncompressSamples.length - 1
                    ].data.value
                  bufferedLogger.append(`  Value: ${currentMeasure.data.value}`)
                }
              }
            } else {
              // bi > BR_HUFF_MAX_INDEX_TABLE
              currentMeasure.data.value = buffer.getNextSample(
                argList[ii].sampletype,
                BM_ST_SZ(argList[ii].sampletype)
              )
              bufferedLogger.append(`Complete: ${currentMeasure.data.value}`)
            }
            currentMeasure.data_relative_timestamp = timestampCommon[i]
            bufferedLogger.append(
              ` TimeStamp: ${currentMeasure.data_relative_timestamp}`
            )
            out.series[ii].uncompressSamples.push(currentMeasure)
          }
        }
      }
    } else {
      console.log("separate time stamp")
      for (let i = 0; i < flag.nb_of_type_measure; i++) {
        tag.lbl = buffer.getNextSample(ST_U8, tagsz)
        const ii = argList.findIndex(
          item => item.taglbl === tag.lbl && tagsz === tag.size
        )
        let compress_samples_nb = buffer.getNextSample(ST_U8, 8)
        console.log(
          ` tag: ${tag.lbl} index ${ii} number of sample ${compress_samples_nb}`
        )
        if (compress_samples_nb) {
          let ltimestamp_coding = buffer.getNextSample(ST_U8, 2)
          console.log(` TimeStamp Coding: ${ltimestamp_coding}`)
          for (let j = 0; j < compress_samples_nb; j++) {
            const currentMeasure = {
              data_relative_timestamp: 0,
              data: {}
            }
            let { sz, bi } = buffer.getNextBifromHi(ltimestamp_coding)
            if (bi <= BR_HUFF_MAX_INDEX_TABLE) {
              if (bi > 0) {
                let t = buffer.getNextSample(ST_U32, bi)
                bufferedLogger.append(
                  `  j: ${j} bi: ${bi} sz: ${sz} Huffindex ${t}`
                )
                currentMeasure.data_relative_timestamp =
                  t +
                  out.series[ii].uncompressSamples[
                    out.series[ii].uncompressSamples.length - 1
                  ].data_relative_timestamp +
                  Math.pow(2, bi) -
                  1
              } else {
                currentMeasure.data_relative_timestamp =
                  out.series[ii].uncompressSamples[
                    out.series[ii].uncompressSamples.length - 1
                  ].data_relative_timestamp
              }
              bufferedLogger.append(
                ` timestamp ${currentMeasure.data_relative_timestamp}`
              )
            } else {
              currentMeasure.data_relative_timestamp = buffer.getNextSample(
                ST_U32,
                BM_ST_SZ(ST_U32)
              )
            }
            if (currentMeasure.data_relative_timestamp > last_timestamp) {
              last_timestamp = currentMeasure.data_relative_timestamp
            }
            const tempBi = buffer.getNextBifromHi(out.series[ii].codingTable)
            sz = tempBi.sz
            bi = tempBi.bi
            if (!sz) {
              throw "sz nul" // Throw or return ?
            }
            bufferedLogger.append(` bi: ${bi} sz: ${sz}`)
            if (bi <= BR_HUFF_MAX_INDEX_TABLE) {
              if (bi > 0) {
                currentMeasure.data.value = buffer.getNextSample(ST_U16, bi)
                bufferedLogger.append(` RawValue: ${currentMeasure.data.value}`)
                // console.log(`Prec = ${out.series[ii].uncompressSamples[out.series[ii].uncompressSamples.length-1].data.value}`);
                if (out.series[ii].codingType === 0) {
                  // ADLC
                  if (currentMeasure.data.value >= Math.pow(2, bi - 1)) {
                    currentMeasure.data.value *= argList[ii].resol
                    currentMeasure.data.value +=
                      out.series[ii].uncompressSamples[
                        out.series[ii].uncompressSamples.length - 1
                      ].data.value
                  } else {
                    currentMeasure.data.value += 1 - Math.pow(2, bi)
                    currentMeasure.data.value *= argList[ii].resol
                    currentMeasure.data.value +=
                      out.series[ii].uncompressSamples[
                        out.series[ii].uncompressSamples.length - 1
                      ].data.value
                  }
                } else if (out.series[ii].codingType === 1) {
                  // Positive
                  let pow = Math.pow(2, bi) - 1
                  currentMeasure.data.value += Math.pow(2, bi) - 1
                  currentMeasure.data.value *= argList[ii].resol
                  currentMeasure.data.value +=
                    out.series[ii].uncompressSamples[
                      out.series[ii].uncompressSamples.length - 1
                    ].data.value
                } else {
                  // Negative
                  currentMeasure.data.value += Math.pow(2, bi) - 1
                  currentMeasure.data.value *= argList[ii].resol
                  currentMeasure.data.value =
                    out.series[ii].uncompressSamples[
                      out.series[ii].uncompressSamples.length - 1
                    ].data.value - currentMeasure.data.value
                }
                bufferedLogger
                  .append(`  Value: ${currentMeasure.data.value}`)
                  .print()
              } else {
                // bi <= 0
                currentMeasure.data.value =
                  out.series[ii].uncompressSamples[
                    out.series[ii].uncompressSamples.length - 1
                  ].data.value
                bufferedLogger
                  .append(`  Value: ${currentMeasure.data.value}`)
                  .print()
              }
            } else {
              // bi > BR_HUFF_MAX_INDEX_TABLE
              currentMeasure.data.value = buffer.getNextSample(
                argList[ii].sampletype,
                BM_ST_SZ(argList[ii].sampletype)
              )
              console.log(` Complete: ${currentMeasure.value}`)
            }
            out.series[ii].uncompressSamples.push(currentMeasure)
          }
        }
      }
    }
  }
  bufferedLogger.print()
  console.log("Timestamp of the sending")
  let globalTimestamp = 0
  if (!last_timestamp) {
    globalTimestamp = buffer.getNextSample(ST_U32, BM_ST_SZ(ST_U32))
  } else {
    const XXX = buffer.getNextBifromHi(1)
    sz = XXX.sz
    bi = XXX.bi
    bufferedLogger.append(`bi: ${bi} sz: ${sz}`)
    if (!sz) {
      throw "sz"
    }
    if (bi <= BR_HUFF_MAX_INDEX_TABLE) {
      if (bi > 0) {
        globalTimestamp = buffer.getNextSample(ST_U32, bi)
        bufferedLogger.append(` raw: ${globalTimestamp}`)
        globalTimestamp += last_timestamp + Math.pow(2, bi) - 1
      } else {
        globalTimestamp = last_timestamp
      }
    } else {
      globalTimestamp = buffer.getNextSample(ST_U32, BM_ST_SZ(ST_U32))
    }
    bufferedLogger.append(` timestamp: ${globalTimestamp}`).print()
    out.batch_relative_timestamp = globalTimestamp
  }

  console.log("\nUNCOMPRESS SERIE")
  console.log(`cnt: ${out.batch_counter}`)
  console.log(out.batch_relative_timestamp)
  out.series.forEach((s, ind) => {
    s.uncompressSamples.forEach(sample => {
      console.log(
        `${sample.data_relative_timestamp} ${argList[ind].taglbl} ${
          sample.data.value
        } ${argList[ind].lblname || ""}`
      )
    })
    if (s.uncompressSamples.length > 0) {
      console.log()
    }
  })

  // Adapt computed value to expected format
  const returnedGlobalObject = {
    batch_counter: out.batch_counter,
    batch_relative_timestamp: out.batch_relative_timestamp
  }
  if (batch_absolute_timestamp) {
    returnedGlobalObject.batch_absolute_timestamp = batch_absolute_timestamp
  }
  returnedGlobalObject.dataset = out.series.reduce((acc, current, index) => {
    return acc.concat(
      current.uncompressSamples.map(item => {
        const returned = {
          data_relative_timestamp: item.data_relative_timestamp,
          data: {
            value: item.data.value,
            label: argList[index].taglbl
          }
        }
        if (argList[index].lblname) {
          returned.data.label_name = argList[index].lblname
        }
        if (batch_absolute_timestamp) {
          returned.data_absolute_timestamp = new Date(
            new Date(batch_absolute_timestamp) -
              (out.batch_relative_timestamp - item.data_relative_timestamp) *
                1000
          ).toISOString()
        }
        return returned
      })
    )
  }, [])
  return returnedGlobalObject
}

module.exports = brUncompress

},{"math-float32-from-bits":6}],2:[function(require,module,exports){
// Exemple d'utilisation de la bibliothèque br_uncompress pour une exécution
// dans le browser

const brUncompress = require("./br_uncompress.js")

window.onload = () => {
  console.log("Test 1")
  document.querySelector("#result").textContent = JSON.stringify(
    brUncompress(
      3,
      [
        {
          taglbl: 2,
          resol: 1.0,
          sampletype: 12,
          lblname: "Foobar"
        }
      ],
      "$10$27$00$80$03$93$20$18$00$80$10$81$83$07$0d$45$85$10$05"
    )
  )
  console.log("Test 2")
  document.querySelector("#result2").textContent = JSON.stringify(
    brUncompress(
      1,
      [
        {
          taglbl: 0,
          resol: 1,
          sampletype: 10
        },
        {
          taglbl: 1,
          resol: 1,
          sampletype: 1
        }
      ],
      "20100000a020a8010000004401e297ad40871b770e377b",
      "2018-11-05T10:35:09.685Z"
    )
  )
}

},{"./br_uncompress.js":1}],3:[function(require,module,exports){
'use strict';

// VARIABLES //

var FLOAT32_VIEW = new Float32Array( 1 );
var UINT32_VIEW = new Uint32Array( FLOAT32_VIEW.buffer );

// 1 11111111 00000000000000000000000 => 4286578688 => 0xff800000 (see IEEE 754-2008)
var NINF = 0xff800000;

// Set the ArrayBuffer bit sequence:
UINT32_VIEW[ 0 ] = NINF;


// EXPORTS //

module.exports = FLOAT32_VIEW[ 0 ];

},{}],4:[function(require,module,exports){
'use strict';

// VARIABLES //

var FLOAT32_VIEW = new Float32Array( 1 );
var UINT32_VIEW = new Uint32Array( FLOAT32_VIEW.buffer );

// 0 11111111 00000000000000000000000 => 2139095040 => 0x7f800000 (see IEEE 754-2008)
var PINF = 0x7f800000;

// Set the ArrayBuffer bit sequence:
UINT32_VIEW[ 0 ] = PINF;


// EXPORTS //

module.exports = FLOAT32_VIEW[ 0 ];

},{}],5:[function(require,module,exports){
'use strict';

// VARIABLES //

var FLOAT32_VIEW = new Float32Array( 1 );


// FLOAT64-TO-FLOAT32 //

/**
* FUNCTION: float64ToFloat32( x )
*	Converts a double-precision floating-point number to the nearest single-precision floating-point number.
*
* @param {Number} x - double-precision floating-point number
* @returns {Number} nearest single-precision floating-point number
*/
function float64ToFloat32( x ) {
	FLOAT32_VIEW[ 0 ] = x;
	return FLOAT32_VIEW[ 0 ];
} // end FUNCTION float64ToFloat32()


// EXPORTS //

module.exports = float64ToFloat32;

},{}],6:[function(require,module,exports){
'use strict';

// MODULES //

var pinf = require( 'const-pinf-float32' );
var ninf = require( 'const-ninf-float32' );
var pow = require( 'math-power' );
var toFloat32 = require( 'float64-to-float32' );
var toFrac = require( './tofrac.js' );


// VARIABLES //

var BIAS = 127;


// FROM BITS //

/**
* FUNCTION: fromBits( bstr )
*	Creates a single-precision floating-point number from an IEEE 754 literal bit representation.
*
* @param {String} bstr - string which is a literal bit representation
* @returns {Number} single-precision floating-point number
*/
function fromBits( bstr ) {
	var sign;
	var frac;
	var exp;

	// Sign bit:
	sign = ( bstr[0] === '1' ) ? -1 : 1;

	// Exponent bits:
	exp = parseInt( bstr.substring(1,9), 2 ) - BIAS;

	// Fraction bits:
	frac = toFrac( bstr.substring( 9 ) );

	// Detect `0` (all 0s) and subnormals (exponent bits are all 0, but fraction bits are not all 0s)...
	if ( exp === -BIAS ) {
		if ( frac === 0 ) {
			return ( sign === 1 ) ? 0 : -0;
		}
		exp = -(BIAS-1); // subnormals are special in that their exponent is constant
	}
	// Detect `+-inf` (exponent bits are all 1 and fraction is 0) and `NaN` (exponent bits are all 1 and fraction is not 0)...
	else if ( exp === BIAS+1 ) {
		if ( frac === 0 ) {
			return ( sign === 1 ) ? pinf : ninf;
		}
		return NaN;
	}
	// Normal numbers...
	else {
		// Account for hidden/implicit bit (2^0):
		frac += 1;
	}
	return toFloat32( sign*frac*pow(2,exp) );
} // end FUNCTION fromBits()


// EXPORTS //

module.exports = fromBits;

},{"./tofrac.js":7,"const-ninf-float32":3,"const-pinf-float32":4,"float64-to-float32":5,"math-power":8}],7:[function(require,module,exports){
'use strict';

// MODULES //

var pow = require( 'math-power' );


// TO FRAC //

/**
* FUNCTION: toFrac( frac )
*	Converts a float's fraction bit sequence to an integer value.
*
* @param {String} frac - literal bit representation of a float's fraction bit sequence
* @returns {Number} integer (floating-point)
*/
function toFrac( frac ) {
	var sum = 0;
	var i;
	for ( i = 0; i < frac.length; i++ ) {
		if ( frac[ i ] === '1' ) {
			sum += pow( 2, -(i+1) );
		}
	}
	return sum;
} // end FUNCTION toFrac()


// EXPORTS //

module.exports = toFrac;

},{"math-power":8}],8:[function(require,module,exports){
'use strict';

// EXPORTS //

module.exports = Math.pow;

},{}]},{},[2]);
